Bug 460103 - kernel: alsa: asoc: fix double free and memory leak in many codec drivers [rhel-5.3]
kernel: alsa: asoc: fix double free and memory leak in many codec drivers [rh...
Status: CLOSED ERRATA
Product: Red Hat Enterprise Linux 5
Classification: Red Hat
Component: kernel (Show other bugs)
5.3
All Linux
medium Severity medium
: rc
: ---
Assigned To: Jaroslav Kysela
Martin Jenner
:
Depends On: 460102
Blocks:
  Show dependency treegraph
 
Reported: 2008-08-26 03:52 EDT by Eugene Teo (Security Response)
Modified: 2009-01-20 15:14 EST (History)
5 users (show)

See Also:
Fixed In Version:
Doc Type: Bug Fix
Doc Text:
Story Points: ---
Clone Of:
Environment:
Last Closed: 2009-01-20 15:14:03 EST
Type: ---
Regression: ---
Mount Type: ---
Documentation: ---
CRM:
Verified Versions:
Category: ---
oVirt Team: ---
RHEL 7.3 requirements from Atomic Host:
Cloudforms Team: ---


Attachments (Terms of Use)

  None (edit)
Description Eugene Teo (Security Response) 2008-08-26 03:52:14 EDT
+++ This bug was initially created as a clone of Bug #460102 +++

Description of problem:
Many SoC audio codec drivers have improper freeing of memory in error paths.

* codec is allocated in the platform device probe function, but is not freed there in case of error. Instead it is freed in the i2c device probe function's error path. However the success or failure of both functions is not linked, so this could result in a double free (if the platform device is successfully probed, the i2c device probing fails and then the platform driver is unregistered.)

* codec->private_data is allocated in many platform device probe functions but not freed in their error paths.

--- Additional comment from eteo@redhat.com on 2008-08-26 03:44:56 EDT ---

Proposed upstream patch:
http://git.kernel.org/?p=linux/kernel/git/torvalds/linux-2.6.git;a=commit;h=3051e41ab7daaa59d4564f20b25dcb8c03f35f2b

--- Additional comment from eteo@redhat.com on 2008-08-26 03:45:45 EDT ---

Created an attachment (id=314967)
Upstream patch for this issue
Comment 1 Eugene Teo (Security Response) 2008-08-26 03:53:22 EDT
We need to backport the wm87{31,50}.c bits to the rhel kernel.
Comment 3 RHEL Product and Program Management 2008-08-28 09:53:41 EDT
This request was evaluated by Red Hat Product Management for inclusion in a Red
Hat Enterprise Linux maintenance release.  Product Management has requested
further review of this request by Red Hat Engineering, for potential
inclusion in a Red Hat Enterprise Linux Update release for currently deployed
products.  This request is not yet committed for inclusion in an Update
release.
Comment 4 Don Zickus 2008-09-05 16:07:08 EDT
in kernel-2.6.18-108.el5
You can download this test kernel from http://people.redhat.com/dzickus/el5
Comment 7 Mike Gahagan 2008-12-09 15:00:36 EST
Confirmed fix is in the -125 kernel.
Comment 9 errata-xmlrpc 2009-01-20 15:14:03 EST
An advisory has been issued which should help the problem
described in this bug report. This report is therefore being
closed with a resolution of ERRATA. For more information
on therefore solution and/or where to find the updated files,
please follow the link below. You may reopen this bug report
if the solution does not work for you.

http://rhn.redhat.com/errata/RHSA-2009-0225.html

Note You need to log in before you can comment on or make changes to this bug.